#include "Streamline.h"

Streamline::Streamline()
{
	pointPos = 0;
}

Streamline::~Streamline(void)
{
}

void Streamline::addPointBack(vec3 pos)
{
	points.push_back(pos);
}

bool Streamline::checkPoint(vec3 pos, float dist, int delta)
{
	int begin = delta;
	int end = points.size() - 1 - delta;

	for(int i = begin; i < end; i++)
	{
		if(pos.dist2(points[i]) < dist)
			return false;
		if(pos.dist2(points[i+1]) < dist)
			return false;

		vec3 d = (points[i+1] - points[i]) / 2.0f;
		d += points[i];

		if(pos.dist2(d) < dist)
			return false;
	}

	return true;
}

vec3 Streamline::getNextCandidate(bool *valid)
{
	if(pointPos >= points.size())
	{
		pointPos = 0;
		*valid = false;
		return vec3(-1.0f, -1.0f);
	}

	vec3 output = points[pointPos];
	pointPos++;
	*valid = true;
	return output;
}

int Streamline::getPointSize()
{
	return points.size();
}